Subject: Label Spaces and Uniqueness

From: Anouk Rocher <[email-masked]>
Date: Mon, 9 Jul 2001 20:45:32 -0400

Eric, Arun, Ross

RFC 3031 in section 3.14 says (in the penultimate paragraph)

  "In MPLS, there is no notion of
   having a different label space for different levels of the hierarchy;
   when interpreting a label, the level of the label is irrelevant."

Does this mean that while doing label stacking, it is neccessary to
allocate labels from a single label space? Isn't this a bit too
restrictive for the cases where the inner label represents
customer traffic transiting a provider and the outer label represents
a path through the provider? 

In other ways, I think it is appropriate in some situations for labels
at different levels of the label-stack to be from different label spaces.

Comments?

Anouk

________________________________________________
Get your own "800" number
Voicemail, fax, email, and a lot more
http://www.ureach.com/reg/tag

---

From: David Charlap <[email-masked]>
Date: Tue, 10 Jul 2001 10:14:27 -0400

Anouk Rocher wrote:
>    having a different label space for different levels of the
>    hierarchy; when interpreting a label, the level of the label is
>    irrelevant."
> 
> allocate labels from a single label space?

Yes.

> Isn't this a bit too restrictive for the cases where the inner
> label represents customer traffic transiting a provider and the
> outer label represents a path through the provider?

What's your alternative?  When a data packet arrives, how are you going
to know what label space the top label should belong to?

-- David

---

From: Eric Gray <[email-masked]>
Date: Tue, 10 Jul 2001 10:59:40 -0400

David and Shahram,

    Two issues: one is that the original question assumes an
erroneous behavior and the other is that the text really is
too restrictive (but so what?).

    The erroneous behavior is the reference to 'inner' labels
that belong to a different domain.  In this case, they are
clearly drawn from a different label 'context' (the fact that
they are drawn from the same 20-bit number space is not at all
interesting).  But this is irrelevant because an LSR would only
see these labels if someone, somewhere, is misbehaving badly.

    The text really is too restrictive because it specifies a
behavior that is strictly of local significance to a single LSR.

    Occasionally, specifications of interoperable behavior will
overstep their boundaries and attempt to specify behaviors that
have little or nothing to do with interoperability.  Often, this
happens in the interest of simplifying the over-all behavioral
description.  When this is the case, this can be (and often is)
a very good thing.  However, where an implementer can be sure a
specification has done this, there is no reason not to depart
from the specified behavior in implementing a behavior that is
strictly of local significance.

    Certainly it is possible for an LSR to use the LSP on which
a labeled packet is received as 'context' for interpreting that
label - as long as the LSR is able to determine which LSP it is
receiving the packet on.  This would be one way to treat an LSP
as a logical interface.  Possible does not equate to easy, so it
may be the case that many LSRs do not do this.  But that does
not mean it won't work.

--
Eric Gray

Shahram Davari wrote:

> Hi,
>
> > -----Original Message-----
> > From: Anouk Rocher [mailto:[email-masked]]
> > Sent: Monday, July 09, 2001 8:46 PM
> > To: [email-masked]
> > Subject: Label Spaces and Uniqueness
> >
> >
> > Eric, Arun, Ross
> >
> > hierarchy;
>  Isn't this a bit too
> No. This rule must be followed. The reason is that an LSR has no way of
> knowing which level of hierarchy a label belongs to.
>
> >
> NO. This is not right. The only time that you may find exactly same labels
> in different layers of hierarchy is when those labels are distributed by two
> different LSRs. This may happen when you have a label stack of more than 2 labels.
>
> -Shahram
>

---

From: Karthik Muthukrishnan <[email-masked]>
Date: Fri, 13 Jul 2001 10:15:42 -0400

Anouk:

I agree with your concerns.. These concerns are the basis of the draft: 

http://search.ietf.org/internet-drafts/draft-kathirvelu-hiervpn-corevpn-00.txt.

A complication is that with penultimate hop popping, every two consecutive labels starting with the first one have to be from the same space. For example, <L1, L2, L3, L4> are the labels with L1 being
the highest on the stack. L1 and L2 are from the same space [say space1] and L3 and L4 are from the same space [say space2] where space1 and space 2 may or not be equal. The choice of whether space1
and space2 are the same and the action when L2 is popped off is left to the implementation; in other words, no wordsmithing in the standard docs is necessary..

-karthik